=== UnitTestFrameworkPkg/Library/CmockaLib/cmocka/meson_options.txt ===
option('unit_testing', type: 'boolean', value: false)
