=== debian/changelog ===
edk2 (2020.11-4) unstable; urgency=medium

  * UEFI/Filesystems.py: Force "/sbin" into $PATH before calling
    mkdosfs, fixing autopkgtest failures.

 -- dann frazier <dannf@debian.org>  Tue, 09 Mar 2021 09:20:12 -0700

edk2 (2020.11-3) unstable; urgency=medium

  * autopkgtest: Avoid needing to use 'atexit' callbacks to cleanup
    uefi variable flash images by implementing a PflashParams object
    that cleans itself up when deleted.
  * autopkgtest: Add missing carriage return to 'reset -s' command
    that is intended to shutdown the guest.
  * autopkgtest: Require guest shutdown to complete.
  * autopkgtest: Add tests to validate secureboot.
  * autopkgtest: Refactor create_efi_bootable_iso() into a subclass of
    EfiBootableIsoImage.
  * autopkgtest: Introduce a series of QemuUefi*Command classes.
  * autopkgtest: Reorganize code into a python package.
  * autopkgtest: Test booting to shell w/ snakeoil vars.
  * Add edk2-vars-generator.py and use it instead of ovmf-vars-generator.
    This tool reuses the UEFI python package, which should allow us to
    more easily add pre-enrolled images for additional architectures.
  * debian/rules: Consolidate list of files to cleanup into debian/clean.
  * Add a OVMF_CODE_4M.snakeoil.fd symlink to help users discover the
    appropriate image to use with OVMF_VARS_4M.snakeoil.fd.
  * debian/rules: Update PkKek-1 selection to allow for derivative
    distributions.
  * autopkgtest: Enable debug output to make it easier to diagnose
    failures.
  * qemu-efi-arm, qemu-efi-aarch64: Enable TPM support. LP: #1901014.

 -- dann frazier <dannf@debian.org>  Mon, 08 Mar 2021 15:31:22 -0700

edk2 (2020.11-2) unstable; urgency=medium

  * autopkgtest: Add allow-stderr to Restrictions to fix failure.

 -- dann frazier <dannf@debian.org>  Tue, 15 Dec 2020 11:42:37 -0700

edk2 (2020.11-1) unstable; urgency=medium

  * New upstream release, based on edk2-stable202011 tag.
  * Version the build-dep on qemu-system-x86 to ensure it is new enough
    to support setting smbios OEM strings on the command line. Thanks to
    Christian Ehrhardt. LP: #1900846.
  * Introduce ovmf-ia32 package. (Closes: #842683)
  * Switch OVMF_CODE_4M images to use a 32-bit PEI phase which supports
    S3 suspend. This avoids having to disable S3 in QEMU to use the
    SMM-enforcing secboot variant. Non-4M images are for backwards
    compatibility only, and remain with a 64-bit PEI phase. LP: #1903681.
    (Closes: #973783)
  * Rework autopkgtests to cover all provided images.

 -- dann frazier <dannf@debian.org>  Sat, 12 Dec 2020 17:57:02 -0700

edk2 (2020.08-1) unstable; urgency=medium

  * New upstream release, based on edk2-stable202008 tag.
  * Drop patches merged upstream:
     - d/p/0001-SecurityPkg-DxeImageVerificationLib-extract-SecDataD.patch
     - d/p/0002-SecurityPkg-DxeImageVerificationLib-assign-WinCertif.patch
     - d/p/0003-SecurityPkg-DxeImageVerificationLib-catch-alignment-.patch
  * Drop patch no longer required due to upstream fixes:
     - d/p/no-missing-braces.diff
  * Refresh patch:
     - d/p/no-stack-protector-all-archs.diff

 -- dann frazier <dannf@debian.org>  Mon, 28 Sep 2020 13:40:05 -0600
