## edk2 2021.08~rc0

=== debian/changelog ===
edk2 (2021.08~rc0-2) experimental; urgency=medium

  * d/p/ftbfs-gcc-11.patch: Use -march=armv7-a+fp instead of -march=armv7-a
    to fix FTBFS w/ the new gcc-11 defaults. (Closes: #992100)

 -- dann frazier <dannf@debian.org>  Wed, 11 Aug 2021 11:24:42 -0600

edk2 (2021.08~rc0-1) experimental; urgency=medium

  * New upstream release, based on edk2-stable202108-rc0 tag.
  * qemu-efi: Set Multi-Arch: foreign, thanks to the Multiarch hinter.

 -- dann frazier <dannf@debian.org>  Mon, 09 Aug 2021 16:13:04 -0600

edk2 (2021.05-1) experimental; urgency=medium

  * New upstream release, based on edk2-stable202105 tag.
  * debian/rules: Only embed required git submodules.

 -- dann frazier <dannf@debian.org>  Fri, 28 May 2021 13:56:57 -0600

edk2 (2021.02-1) experimental; urgency=medium

  * New upstream release, based on edk2-stable202102 tag.
  * Drop qemu-ovmf-secureboot which is no longer used.
  * debian/control: Make versioned build-dep on qemu-system-x86 backport
    safe.
  * Add pre-enrolled "ms" and "snakeoil" variants of AAVMF templates.
  * d/p/BaseTools-Fix-the-lib-order-in-static_library_files..patch:
    Remove orphaned patch.
  * debian/control: Drop unnecessary Testsuite field.

 -- dann frazier <dannf@debian.org>  Tue, 09 Mar 2021 13:23:59 -0700
