=== debian/control ===
--- 
+++ 
@@ -17,14 +17,14 @@
  python3-distutils,
  python3-pexpect,
  qemu-utils,
- qemu-system-x86 (>= 1:2.12+dfsg-1),
+ qemu-system-arm (>= 1:2.12+dfsg),
+ qemu-system-x86 (>= 1:2.12+dfsg),
  uuid-dev,
  xorriso,
 Standards-Version: 4.5.0
 Homepage: http://www.tianocore.org
 Vcs-Git: https://salsa.debian.org/qemu-team/edk2.git
 Vcs-Browser: https://salsa.debian.org/qemu-team/edk2
-Testsuite: autopkgtest
 XS-Build-Indep-Architecture: amd64
 
 Package: ovmf
@@ -66,6 +66,7 @@
 Package: qemu-efi
 Architecture: all
 Depends: qemu-efi-aarch64, ${misc:Depends}
+Multi-Arch: foreign
 Description: transitional dummy package
  This is a transitional dummy package. It contains a compatibility symlink
  of /usr/share/qemu-efi/QEMU_EFI.fd to /usr/share/qemu-efi-aarch64/QEMU_EFI.fd.
