=== debian/rules ===
--- 
+++ 
@@ -69,6 +69,13 @@
 AAVMF_ENROLL    = $(AAVMF_BUILD_DIR)/AARCH64/EnrollDefaultKeys.efi
 AAVMF_SHELL     = $(AAVMF_BUILD_DIR)/AARCH64/Shell.efi
 AAVMF_BINARIES  = $(AAVMF_ENROLL) $(AAVMF_SHELL)
+AAVMF_CODE      = $(AAVMF_BUILD_DIR)/FV/AAVMF_CODE.fd
+AAVMF_VARS      = $(AAVMF_BUILD_DIR)/FV/AAVMF_VARS.fd
+AAVMF_IMAGES    = $(AAVMF_CODE) $(AAVMF_VARS)
+AAVMF_PREENROLLED_VARS = $(addprefix $(AAVMF_BUILD_DIR)/FV/,AAVMF_VARS.ms.fd AAVMF_VARS.snakeoil.fd)
+
+AAVMF32_BUILD_DIR = Build/ArmVirtQemu-ARM/RELEASE_$(EDK2_TOOLCHAIN)
+AAVMF32_IMAGES    = $(AAVMF32_BUILD_DIR)/FV/,AAVMF32_CODE.fd AAVMF32_VARS.fd)
 
 build-ovmf32: $(OVMF32_BINARIES) $(OVMF32_IMAGES)
 $(OVMF32_BINARIES) $(OVMF32_IMAGES): debian/setup-build-stamp
@@ -134,6 +141,20 @@
 	tr -d '\n' < $< | \
 		sed -e 's/.*-----BEGIN CERTIFICATE-----/4e32566d-8e9e-4f52-81d3-5bb9715f9727:/' -e 's/-----END CERTIFICATE-----//' > $@
 
+%/AAVMF_VARS.ms.fd: %/AAVMF_CODE.fd %/AAVMF_VARS.fd debian/oem-string-vendor $(AAVMF_ENROLL) $(AAVMF_SHELL)
+	PYTHONPATH=$(CURDIR)/debian/python \
+	./debian/edk2-vars-generator.py \
+		-f AAVMF -e $(AAVMF_ENROLL) -s $(AAVMF_SHELL) \
+		-c $(AAVMF_CODE) -V $(AAVMF_VARS) \
+		-C `< debian/oem-string-vendor` -o $@
+
+%/AAVMF_VARS.snakeoil.fd: %/AAVMF_CODE.fd %/AAVMF_VARS.fd debian/oem-string-snakeoil $(AAVMF_ENROLL) $(AAVMF_SHELL)
+	PYTHONPATH=$(CURDIR)/debian/python \
+	./debian/edk2-vars-generator.py \
+		-f AAVMF -e $(AAVMF_ENROLL) -s $(AAVMF_SHELL) \
+		-c $(AAVMF_CODE) -V $(AAVMF_VARS) \
+		-C `< debian/oem-string-snakeoil` -o $@
+
 %/OVMF_VARS.ms.fd: %/OVMF_CODE.fd %/OVMF_VARS.fd debian/oem-string-vendor $(OVMF_ENROLL) $(OVMF_SHELL)
 	PYTHONPATH=$(CURDIR)/debian/python \
 	./debian/edk2-vars-generator.py \
@@ -174,7 +195,7 @@
 	dd if=$(QEMU_EFI_BUILD_DIR)/FV/QEMU_EFI.fd of=$(QEMU_EFI_BUILD_DIR)/FV/$(FW_NAME)_CODE.fd conv=notrunc
 	dd if=/dev/zero of=$(QEMU_EFI_BUILD_DIR)/FV/$(FW_NAME)_VARS.fd bs=1M seek=64 count=0
 
-build-qemu-efi-aarch64: $(AAVMF_BINARIES)
+build-qemu-efi-aarch64: $(AAVMF_BINARIES) $(AAVMF_PREENROLLED_VARS)
 $(AAVMF_BINARIES): ArmPkg/Library/GccLto/liblto-aarch64.a
 	$(MAKE) -f debian/rules build-qemu-efi EDK2_ARCH_DIR=AArch64 EDK2_HOST_ARCH=AARCH64 FW_NAME=AAVMF
 
@@ -183,25 +204,3 @@
 
 override_dh_auto_clean:
 	-. ./edksetup.sh; build clean
-	make -C BaseTools clean
-
-get-orig-source:
-	# Should be executed on a checkout of the upstream master branch,
-	# with the debian/ directory manually copied in.
-	rm -rf edk2.tmp && git clone . edk2.tmp
-	# Don't recurse, openssl will bring in MBs of stuff we don't need
-	cd edk2.tmp && git submodule update --init
-	rm -rf edk2-$(DEB_VERSION_UPSTREAM) && \
-		mkdir edk2-$(DEB_VERSION_UPSTREAM)
-	cd edk2.tmp && git archive HEAD | \
-		tar xv -C ../edk2-$(DEB_VERSION_UPSTREAM)
-	cd edk2.tmp && git submodule foreach \
-		'git archive HEAD | tar xv -C $$toplevel/../edk2-$(DEB_VERSION_UPSTREAM)/$$sm_path'
-	ln -s ../debian edk2-$(DEB_VERSION_UPSTREAM)
-	# Remove unused embedded source, requested by Ubuntu security team
-	rm -r edk2-$(DEB_VERSION_UPSTREAM)/BaseTools/Source/C/BrotliCompress
-	# Remove known-binary files
-	cd edk2-$(DEB_VERSION_UPSTREAM) && python3 ./debian/remove-binaries.py
-	# Look for possible unknown binary files
-	cd edk2-$(DEB_VERSION_UPSTREAM) && python3 ./debian/find-binaries.py
-	rm edk2-$(DEB_VERSION_UPSTREAM)/debian
