=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: edk2
 Section: misc
 Priority: optional
-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
 Uploaders: Steve Langasek <vorlon@debian.org>, Serge Hallyn <serge.hallyn@ubuntu.com>, dann frazier <dannf@debian.org>
 Build-Depends: bc,
  debhelper-compat (= 12),
  dosfstools,
  dpkg (>= 1.19.3),
  gcc-aarch64-linux-gnu,
- gcc-arm-linux-gnueabihf,
+ gcc-arm-linux-gnueabi,
  gcc-multilib [i386],
  iasl,
  mtools,
