=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 EDK2_TOOLCHAIN = GCC5
 export $(EDK2_TOOLCHAIN)_AARCH64_PREFIX=aarch64-linux-gnu-
-export $(EDK2_TOOLCHAIN)_ARM_PREFIX=arm-linux-gnueabihf-
+export $(EDK2_TOOLCHAIN)_ARM_PREFIX=arm-linux-gnueabi-
 
 export PYTHON3_ENABLE=TRUE
 
@@ -20,8 +20,12 @@
 	EDK2_BUILD_ARCH=AARCH64
 endif
 
-COMMON_FLAGS = -DNETWORK_HTTP_BOOT_ENABLE=TRUE -DNETWORK_TLS_ENABLE -DSECURE_BOOT_ENABLE=TRUE
-OVMF_COMMON_FLAGS = $(COMMON_FLAGS) -DTPM_ENABLE=TRUE
+COMMON_FLAGS  = -DNETWORK_HTTP_BOOT_ENABLE=TRUE
+COMMON_FLAGS += -DNETWORK_IP6_ENABLE=TRUE
+COMMON_FLAGS += -DNETWORK_TLS_ENABLE
+COMMON_FLAGS += -DSECURE_BOOT_ENABLE=TRUE
+COMMON_FLAGS += -DTPM2_ENABLE=TRUE
+OVMF_COMMON_FLAGS = $(COMMON_FLAGS)
 OVMF_2M_FLAGS = $(OVMF_COMMON_FLAGS) -DFD_SIZE_2MB
 OVMF_4M_FLAGS = $(OVMF_COMMON_FLAGS) -DFD_SIZE_4MB
 OVMF_2M_SMM_FLAGS = $(OVMF_2M_FLAGS) -DSMM_REQUIRE=TRUE
@@ -29,9 +33,7 @@
 OVMF32_4M_FLAGS = $(OVMF_COMMON_FLAGS) -DFD_SIZE_4MB
 OVMF32_4M_SMM_FLAGS =  $(OVMF32_4M_FLAGS) -DSMM_REQUIRE=TRUE
 
-AAVMF_FLAGS  = $(COMMON_FLAGS) -DTPM2_ENABLE=TRUE -DTPM2_CONFIG_ENABLE=TRUE
-
-OVMF_VARS_GENERATOR = ./qemu-ovmf-secureboot-1-1-3/ovmf-vars-generator
+AAVMF_FLAGS  = $(COMMON_FLAGS) -DTPM2_CONFIG_ENABLE=TRUE
 
 # Clear variables used internally by the edk2 build system
 undefine WORKSPACE
@@ -153,6 +155,7 @@
 	./debian/edk2-vars-generator.py \
 		-f AAVMF -e $(AAVMF_ENROLL) -s $(AAVMF_SHELL) \
 		-c $(AAVMF_CODE) -V $(AAVMF_VARS) \
+		--no-default \
 		-C `< debian/oem-string-snakeoil` -o $@
 
 %/OVMF_VARS.ms.fd: %/OVMF_CODE.fd %/OVMF_VARS.fd debian/oem-string-vendor $(OVMF_ENROLL) $(OVMF_SHELL)
@@ -177,6 +180,7 @@
 		-f OVMF_4M -e $(OVMF_ENROLL) -s $(OVMF_SHELL) \
 		-c debian/ovmf-install/OVMF_CODE_4M.fd \
 		-V debian/ovmf-install/OVMF_VARS_4M.fd \
+		--no-default \
 		-C `< debian/oem-string-snakeoil` -o $@
 
 ArmPkg/Library/GccLto/liblto-aarch64.a:	ArmPkg/Library/GccLto/liblto-aarch64.s
@@ -203,4 +207,3 @@
 	$(MAKE) -f debian/rules build-qemu-efi EDK2_ARCH_DIR=Arm EDK2_HOST_ARCH=ARM FW_NAME=AAVMF32
 
 override_dh_auto_clean:
-	-. ./edksetup.sh; build clean
