## edk2 2022.05

=== debian/changelog ===
edk2 (2022.05-4) unstable; urgency=medium

  * autopkgtest: Fix regression in test_aavmf_ms_secure_boot_unsigned
    by porting it to the new GrubShellBootableIsoImage interface.

 -- dann frazier <dannf@debian.org>  Wed, 07 Sep 2022 07:23:15 -0600

edk2 (2022.05-3) unstable; urgency=medium

  * Enroll snakeoil keys w/ EnrollDefaultKeys.efi --no-default, fixing
    a regression introduced with the transition to edk2-vars-generator.py.
    LP: #1986692.
  * Clear the BootOrder EFI variable after enrolling keys.
    (Closes: #1015759)
  * autopkgtest: Move bootloader selection logic out of Filesystems.py.
  * autopkgtest: Add snakeoil regression tests.

 -- dann frazier <dannf@debian.org>  Tue, 06 Sep 2022 09:18:46 -0600

edk2 (2022.05-2) unstable; urgency=medium

  * d/p/x64-baseline-abi.patch: Override microarchitecture ABI for x64
    to retain compatibility with generic x86-64 platforms. LP: #1976267.

 -- dann frazier <dannf@debian.org>  Mon, 06 Jun 2022 18:48:56 +0100

edk2 (2022.05-1) unstable; urgency=medium

  * New upstream release, based on edk2-stable202205 tag.
  * Drop patches merged upstream:
    - d/p/0001-OvmfPkg-OvmfPkgX64-Use-different-CcProbeLib-when-SMM.patch

 -- dann frazier <dannf@debian.org>  Fri, 03 Jun 2022 10:29:46 +0100

edk2 (2022.05~rc1-1) unstable; urgency=medium

  * New upstream release, based on edk2-stable202205-rc1 tag.
  * Drop patches merged upstream:
    - d/p/0001-MdeModulePkg-NvmExpressDxe-fix-check-for-Cap.Css.patch
    - d/p/0002-MdeModulePkg-NvmExpressPei-fix-check-for-NVM-command.patch
  * ovmf: Fix boot hang with SMM enabled:
    - d/p/0001-OvmfPkg-OvmfPkgX64-Use-different-CcProbeLib-when-SMM.patch

 -- dann frazier <dannf@debian.org>  Tue, 17 May 2022 09:59:17 -0600
